(function($){
    //Attach this new method to jQuery
    $.fn.extend({ 
          
        pinit: function(options) {
  
            var defaults = {
                wrap: '<span class="pinit"/>',
                pageURL: document.URL,
				pageTitle: document.title
            }
			if (options.description_option == 3)
				defaults.pageDescription = $('meta[name="description"]').attr('content');
			
            var o = $.extend(defaults, options);
			var discriminator_classes = o.disabled_classes.split(';');
			
			if (!(typeof o.enabled_classes === 'undefined')) //variable exists
				var allowed_classes = o.enabled_classes.split(';');

            //Iterate over the current set of matched elements
            return this.each(function(i) {
				if (!(typeof allowed_classes === 'undefined')) {//variable exists
					var has_class = false;
					for(var c in allowed_classes){
						if($(this).hasClass(allowed_classes[c])){
							has_class = true;
							break;
						}
					}
					if (!has_class)
						return;
				}
				
				for(var c in discriminator_classes){
					if($(this).hasClass(discriminator_classes[c]))
						return;
				}
				
				//to identify the image when loaded
				$(this).attr('indexer', i);
					
                var e = $(this),
                    pi_media = e.data('media') ? e.data('media') : e[0].src,
                    pi_url = o.pageURL,
                    pi_isvideo = 'false';
				
				//Pin message depending on settings
				var pi_desc;
				if (o.description_option == 3)
					pi_desc = e.attr('title') ? e.attr('title') : e.attr('alt');
				else if (o.description_option == 2)
					pi_desc = o.pageDescription;
				if (!pi_desc)
					pi_desc = o.pageTitle;
					
                bookmark = 'http://pinterest.com/pin/create/bookmarklet/?media=' + encodeURI(pi_media) + '&url=' + encodeURI(pi_url) + '&is_video=' + encodeURI(pi_isvideo) + '&description=' + encodeURI(pi_desc);

                e.wrap(o.wrap);				
                e.after('<span class="pinit-overlay" style=" indexer= "' + i + '"><a href="' + bookmark + '" class="pinit-button">Pin It</a></span>');
				
				$(this).load(function(){
					var indexer = $(this).attr("indexer");
					$('span[indexer="' + indexer + '"]').css('height', $(this).innerHeight() + 'px');
				});
                 
                $('.pinit .pinit-button').on('click', function () {             
                    window.open($(this).attr('href'), 'Pinterest', 'width=632,height=253,status=0,toolbar=0,menubar=0,location=1,scrollbars=1');                
                    return false;
                });     
                 
                $('.pinit').mouseenter(function () {
                    $(this).children('.pinit-overlay').fadeIn(200);
                }).mouseleave(function () {
                    $(this).children('.pinit-overlay').fadeOut(200);
                });
 
            });
        }
    });
})(jQuery);